.386
.model flat,stdcall
option casemap:none

include Test02.inc

.code

start:

	invoke	GetModuleHandle,NULL
	mov	hInstance,eax
	
	invoke	GetCommandLine
	mov	CommandLine,eax
	
	invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
	invoke ExitProcess,eax

	invoke InitCommonControls

TV_AddItem	proc	hTreeview:HWND, hParentItem:DWORD, lpszText:LPCTSTR, imgNormal:DWORD, imgSelected:DWORD, fBold:BOOL, fSort:BOOL
	LOCAL	tvins:TV_INSERTSTRUCT
	
	mov	eax,hParentItem
	mov	tvins.hParent,eax
	
	.if	fSort == TRUE
		mov	eax, TVI_SORT
	.else
		mov	eax, TVI_LAST
	.endif
	mov	tvins.hInsertAfter, eax
	
	mov	tvins.item._mask, TVIF_TEXT or TVIF_IMAGE or TVIF_SELECTEDIMAGE
	
	.if	fBold == TRUE
		or	tvins.item._mask, TVIF_STATE
	.endif
	
	mov	eax,lpszText
	mov	tvins.item.pszText,eax
	
	mov	eax,imgNormal
	mov	tvins.item.iImage,eax
	
	mov	eax,imgSelected
	mov	tvins.item.iSelectedImage,eax
	
	.if	fBold == TRUE
		mov	tvins.item.state,TVIS_BOLD
		mov	tvins.item.stateMask,TVIS_BOLD
	.endif
	
	invoke	SendMessage,hTreeview,TVM_INSERTITEM,0,addr tvins
	
	ret
TV_AddItem	endp

TreeviewSubClassProc	proc	hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	mov	eax, uMsg
	.if	eax == WM_DROPFILES
		invoke	MessageBox, hWin, 0, 0, MB_ICONASTERISK
		
		invoke	DragQueryPoint, wParam, offset g_htTemp.pt
		
		invoke	SendMessage, g_hTreeview, TVM_HITTEST, 0, offset g_htTemp
		.if	eax == NULL
			;dragged stuff not over any particular item, so get default
			invoke	SendMessage, g_hTreeview, TVM_GETNEXTITEM, TVGN_CARET, 0
		.endif
		.if	eax == NULL
			jmp	@f
		.endif
		mov	g_hTemp, eax
		
		invoke	SendMessage, g_hTreeview, TVM_SELECTITEM, TVGN_CARET, g_hTemp
		
		invoke	DragQueryFile, wParam, -1, offset m_szDropFile, MAX_PATH
		mov	ebx, eax
		xor	ecx, ecx
		.while	ecx < ebx
			push	ebx
			push	ecx
			
			invoke	DragQueryFile, wParam, ecx, offset m_szDropFile, MAX_PATH
			
			invoke	TV_AddItem, g_hTreeview, g_hTemp, offset m_szDropFile, 0, 0, FALSE, TRUE
			
			pop	ecx
			inc	ecx
			pop	ebx
		.endw
		
		invoke	SendMessage, g_hTreeview, TVM_EXPAND, TVE_EXPAND, g_hTemp
	@@:			
	.else
		invoke	CallWindowProc, lpfnPrevTVFunc, hWin, uMsg, wParam, lParam
		ret
	.endif
	
	xor	eax, eax
	ret

TreeviewSubClassProc endp

ChildDlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		invoke	GetDlgItem, hWin, IDC_TRV1
		mov	g_hTreeview, eax
		
		invoke	TV_AddItem, g_hTreeview, TVI_ROOT, offset ClassName, 0, 0, TRUE, TRUE
		
		invoke	SetFocus, g_hTreeview
		
		invoke	SetWindowLong, g_hTreeview, GWL_WNDPROC, offset TreeviewSubClassProc
		mov	lpfnPrevTVFunc, eax
		
	.elseif eax==WM_COMMAND

	.elseif eax==WM_DESTROY
		
	.else
		mov		eax,FALSE
		ret
	.endif
	mov		eax,TRUE
	ret

ChildDlgProc endp

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL	wc:WNDCLASSEX
	LOCAL	msg:MSG

	mov		wc.cbSize,sizeof WNDCLASSEX
	mov		wc.style,CS_HREDRAW or CS_VREDRAW
	mov		wc.lpfnWndProc,offset WndProc
	mov		wc.cbClsExtra,NULL
	mov		wc.cbWndExtra,DLGWINDOWEXTRA
	push	hInst
	pop		wc.hInstance
	mov		wc.hbrBackground,COLOR_BTNFACE+1
	mov		wc.lpszMenuName,IDM_MENU
	mov		wc.lpszClassName,offset ClassName
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov		wc.hIcon,eax
	mov		wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov		wc.hCursor,eax
	invoke RegisterClassEx,addr wc
	invoke CreateDialogParam,hInstance,IDD_DIALOG,NULL,addr WndProc,NULL
	mov	hWnd, eax
	invoke ShowWindow,hWnd,SW_SHOWNORMAL
	invoke UpdateWindow,hWnd
	
	invoke	CreateDialogParam, hInstance, IDD_CHILD, hWnd, ChildDlgProc, 0
	
	.while TRUE
		invoke GetMessage,addr msg,NULL,0,0
	  .BREAK .if !eax
		invoke TranslateMessage,addr msg
		invoke DispatchMessage,addr msg
	.endw
	mov		eax,msg.wParam
	ret

WinMain endp

WndProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		push	hWin
		pop		hWnd
		
		invoke	GetDlgItem, hWin, IDC_GRP1
		invoke	SetWindowPos, eax,HWND_BOTTOM, 0, 0, 0, 0, SWP_NOREPOSITION or SWP_NOSIZE or SWP_SHOWWINDOW 

	.elseif eax==WM_COMMAND
		mov		eax,wParam
		and		eax,0FFFFh
		.if eax==IDM_FILE_EXIT
			invoke SendMessage,hWin,WM_CLOSE,0,0
		.elseif eax==IDM_HELP_ABOUT
			invoke ShellAbout,hWin,addr AppName,addr AboutMsg,NULL
		.endif
;	.elseif eax==WM_SIZE
	.elseif eax==WM_CLOSE
		invoke DestroyWindow,hWin
	.elseif uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL
	.else
		invoke DefWindowProc,hWin,uMsg,wParam,lParam
		ret
	.endif
	xor    eax,eax
	ret

WndProc endp

end start
